import { DEFAULT_FUNCTION_REGISTRY } from "./features/feature_indicators_formulaes";
import { StrategyRunner } from "./features/feature_strategy_runner";
import * as fs from "fs";
const r = fs.readFileSync(process.cwd() + "/src/sample_ohlc.json", "utf-8");
const rs = JSON.parse(r);
const candles = rs.data.symbol_ticks
    .map((item) => ({
    ...item,
    open: item.open / 1000,
    close: item.close / 1000,
    high: item.high / 1000,
    low: item.low / 1000,
}))
    .slice(0, 250);
// const parser = new DSLParser(mockCandles, function_registry);
// const index = 2;
// const result = parser.evaluate("ema(2, 3)", { entry_price: 22 });
// console.log(`DSL at index ${index}:`, result);
const s_schema = {
    name: "test",
    entry_long: "ema(9, 0) > ema(21, 0)",
    exit_long: "ema(9, 0) < ema(21, 0)",
    capital: 1000,
    stop_loss_expr: "entry_price() * 0.995",
};
const strat = new StrategyRunner(candles, s_schema, DEFAULT_FUNCTION_REGISTRY);
const res = strat.run();
const report = strat.get_report();
console.log(report);
//# sourceMappingURL=test.js.map